prawokultury/urls.py
# -*- coding: utf-8 -*-
# This file is part of PrawoKultury, licensed under GNU Affero GPLv3 or later.
# Copyright © Fundacja Nowoczesna Polska. See NOTICE for more information.
#
from django.conf import settings
from django.conf.urls import include, url
from django.contrib import admin
import django.contrib.sitemaps.views
from django.contrib.staticfiles.urls import staticfiles_urlpatterns
from django.utils.translation import ugettext_lazy as _, string_concat
import django_cas_ng.views
from fnpdjango.utils.urls import i18n_patterns
from events.urls import urlpatterns as events_urlpatterns
from migdal.urls import urlpatterns as migdal_urlpatterns
from migdal.sitemap import sitemaps as migdal_sitemaps
from questions.sitemap import sitemaps as question_sitemaps


urlpatterns = [
    url(r'^taggit_autosuggest/', include('taggit_autosuggest.urls')),

    url(r'^sitemap\.xml$', django.contrib.sitemaps.views.sitemap, {
        'sitemaps': dict(migdal_sitemaps.items() + question_sitemaps.items())
    }),

    url(r'^accounts/login/$', django_cas_ng.views.login),
    url(r'^accounts/logout/$', django_cas_ng.views.logout),
    url(r'^admin/login/$', django_cas_ng.views.login),
    url(r'^admin/logout/$', django_cas_ng.views.logout),

    url(r'^admin/doc/', include('django.contrib.admindocs.urls')),
    url(r'^admin/', admin.site.urls),
]

urlpatterns += i18n_patterns(
    url(string_concat(r'^', _('events'), r'/'), include('events.urls')),
    url(r'^comments/', include('django_comments_xtd.urls')),
    url(r'^pierwsza-pomoc/', include('questions.urls')),
    url(string_concat(r'^', _('shop'), r'/'), include('shop.urls')),
) + migdal_urlpatterns 

if settings.DEBUG:
    import django.views.static
    urlpatterns += [
        url(r'^media/(?P<path>.*)$', django.views.static.serve, {
            'document_root': settings.MEDIA_ROOT,
        }),
   ]

urlpatterns += staticfiles_urlpatterns()

questions/urls.py
# -*- coding: utf-8 -*-
# This file is part of PrawoKultury, licensed under GNU Affero GPLv3 or later.
# Copyright © Fundacja Nowoczesna Polska. See NOTICE for more information.
#
from django.conf.urls import url
from django.views.generic import DetailView, TemplateView
from .models import Question
from .views import QuestionFormView, QuestionListView

urlpatterns = [
    url(r'^$',
        QuestionListView.as_view(),
        name="questions"
    ),
    url(r'^(?P<pk>\d+)/$',
        DetailView.as_view(queryset=Question.objects.filter(published=True)),
        name="questions_question"),
    url(r'^pytanie/$',
        QuestionFormView.as_view(),
        name="questions_form",
    ),
    url(r'^pytanie/dziekujemy/$',
        TemplateView.as_view(
            template_name="questions/question_thanks.html",
        ),
        name="questions_thanks"
    ),
]

shop/urls.py
# -*- coding: utf-8 -*-
# This file is part of PrawoKultury, licensed under GNU Affero GPLv3 or later.
# Copyright © Fundacja Nowoczesna Polska. See NOTICE for more information.
#
from django.conf.urls import url, include
from django.utils.translation import ugettext_lazy as _
from django.views.decorators.csrf import csrf_exempt
from getpaid.backends.payu.views import OnlineView
from prawokultury.middleware import honeypot_exempt
from .views import ThanksView, NoThanksView, OfferDetailView


urlpatterns = [
    url(r'^kup/(?P<slug>[^/]+)/$', OfferDetailView.as_view(), name='shop_buy'),
    url(r'^dziekujemy/(?P<pk>\d+)/$', ThanksView.as_view(), name='shop_thanks'),
    url(r'^niepowodzenie/(?P<pk>\d+)/$', NoThanksView.as_view(), name='shop_nothanks'),
    url(r'^getpaid/getpaid.backends.payu/online/$', 
            honeypot_exempt(csrf_exempt(OnlineView.as_view())),
            name='getpaid-payu-online'),
    url(r'^getpaid/', include('getpaid.urls')),
]

questions/models.py
# -*- coding: utf-8
from datetime import datetime
from django.conf import settings
from django.contrib.sites.models import Site
from django.core.mail import EmailMultiAlternatives
from django.db import models
from django.template import loader, Context
from django.utils.translation import ugettext_lazy as _
from markupfield.fields import MarkupField
from taggit.models import TagBase, GenericTaggedItemBase
from taggit_autosuggest.managers import TaggableManager
from slugify import slugify


class TagCategory(models.Model):
    name = models.CharField(verbose_name=_('Name'), unique = True, max_length = 100)
    slug = models.SlugField(verbose_name=_('Slug'), unique = True, max_length = 100)

    class Meta:
        verbose_name = _("Tag Category")
        verbose_name_plural = _("Tag Categories")
        
    def __unicode__(self):
        return self.name
    
    
class Tag(TagBase):
    def slugify(self, tag, i=None):
        slug = slugify(tag)
        if i is not None:
            slug += "_%d" % i
        return slug

    category = models.ForeignKey(TagCategory, blank = True, null = True, on_delete = models.SET_NULL, related_name = 'tags')
    click_count = models.IntegerField(null = False, default = 0)
    
    class Meta:
        verbose_name = _("Tag")
        verbose_name_plural = _("Tags")


class TagItem(GenericTaggedItemBase):
    tag = models.ForeignKey(Tag, on_delete=models.CASCADE, related_name="items")
 

class Question(models.Model):
    email = models.EmailField(_('contact e-mail'), null=True, blank=True)
    question = models.TextField(_('question'), db_index=False)
    created_at = models.DateTimeField(_('created at'), auto_now_add=True)
    changed_at = models.DateTimeField(_('changed at'), auto_now=True)
    approved = models.BooleanField(_('approved'), default=False)
    edited_question = models.TextField(_('edited question'), db_index=False, null=True, blank=True,
            help_text=_("Leave empty if question doesn't need editing."))
    answer = MarkupField(_('answer'), markup_type='textile_pl', blank=True,
            help_text=_('Use <a href="http://txstyle.org/">Textile</a> syntax.'))
    answered_by = models.CharField(_('answered by'), max_length=127, null=True, blank=True)
    answered = models.BooleanField(_('answered'), db_index=True, default=False,
            help_text=_('Check to send the answer to user.'))
    answered_at = models.DateTimeField(_('answered at'), null=True, blank=True, db_index=True)
    published = models.BooleanField(_('published'), db_index=True, default=False,
        help_text=_('Check to display answered question on site.'))
    published_at = models.DateTimeField(_('published at'), null=True, blank=True, db_index=True)

    tags = TaggableManager(through=TagItem, blank=True)

    class Meta:
        ordering = ['-created_at']
        verbose_name = _('question')
        verbose_name_plural = _('questions')

    def __unicode__(self):
        return self.edited_question or self.question

    @models.permalink
    def get_absolute_url(self):
        return ('questions_question', (self.pk,))

    def notify_author(self):
        if not self.email:
            return
        site = Site.objects.get_current()
        context = Context({
                'question': self,
                'site': site,
            })
        text_content = loader.get_template('questions/answered_mail.txt'
            ).render(context)
        html_content = loader.get_template('questions/answered_mail.html'
            ).render(context)
        msg = EmailMultiAlternatives(
            u'Odpowiedź na Twoje pytanie w serwisie %s.' % site.domain,
            text_content, settings.SERVER_EMAIL, [self.email])
        msg.attach_alternative(html_content, "text/html")
        msg.send()

    def ack_author(self):
        if not self.email:
            return
        site = Site.objects.get_current()
        context = Context({
                'question': self,
                'site': site,
            })
        text_content = loader.get_template('questions/ack_mail.txt'
            ).render(context)
        html_content = loader.get_template('questions/ack_mail.html'
            ).render(context)
        msg = EmailMultiAlternatives(
            u'Twoje pytanie zostało zarejestrowane w serwisie %s.' % site.domain,
            text_content, settings.SERVER_EMAIL, [self.email])
        msg.attach_alternative(html_content, "text/html")
        msg.send()

    def save(self, *args, **kwargs):
        now = datetime.now()
        notify = False
        if self.answered and not self.answered_at:
            notify = True
            self.answered_at = now
        if self.published and not self.published_at:
            self.published_at = now
        ret = super(Question, self).save(*args, **kwargs)
        if notify:
            self.notify_author()
        return ret

questions/forms.py
from django.forms import ModelForm
from .models import Question

class QuestionForm(ModelForm):
    required_css_class = 'required'

    class Meta:
        model = Question
        fields = ['email', 'question']

    def save(self, *args, **kwargs):
        instance = super(QuestionForm, self).save(*args, **kwargs)
        instance.ack_author()
        return instance

questions/views.py
# -*- coding: utf-8 -*-
# This file is part of PrawoKultury, licensed under GNU Affero GPLv3 or later.
# Copyright © Fundacja Nowoczesna Polska. See NOTICE for more information.
#
from django.core.urlresolvers import reverse_lazy
from django.db import models
from django.shortcuts import get_object_or_404
from django.views.generic import ListView
from django.views.generic.edit import FormView
from .forms import QuestionForm
from .models import Question, Tag, TagCategory


class QuestionFormView(FormView):
    form_class = QuestionForm
    template_name = "questions/question_form.html"
    success_url = reverse_lazy("questions_thanks")

    def form_valid(self, form):
        form.save()
        return super(QuestionFormView, self).form_valid(form)


class QuestionListView(ListView):
    def get(self, request, *args, **kwargs):
        self.tag = None
        if 'tag' in request.GET:
            try:
                tag = Tag.objects.get(slug=request.GET['tag'])
                assert Question.objects.filter(tags=self.tag).exists()
            except (Tag.DoesNotExist, AssertionError):
                pass
            else:
                self.tag = tag
        return super(QuestionListView, self).get(request, *args, **kwargs)

    def get_queryset(self):
        qs = Question.objects.filter(published=True
                ).order_by('-published_at')
        if self.tag:
            qs = qs.filter(tags=self.tag)
            self.tag.click_count += 1
            self.tag.save()
        return qs

    def get_context_data(self, *args, **kwargs):
        def get_cloud_size(clicks, relate_to):
            return '%.2f' % (0.7 + (float(clicks) / relate_to if relate_to != 0 else 0))
        
        context = super(QuestionListView, self).get_context_data(*args, **kwargs)
        context['tag'] = self.tag
        context['tag_categories'] = TagCategory.objects.all().annotate(click_count = models.Sum('tags__click_count'))
        context['tag_lists'] = dict()
        
        annotated_categories = dict()
        all_tags_click_count = Tag.objects.all().aggregate(models.Sum('click_count'))['click_count__sum']
        for category in context['tag_categories']:
            annotated_categories[category.id] = category
            category.cloud_size =  get_cloud_size(category.click_count, all_tags_click_count)

        # This wouldn't happen if we were using taggit without generic relations.
        tags = Tag.objects.raw("""
            SELECT t.category_id, t.click_count, t.id, t.name, t.slug, count(t.id) AS c
            FROM questions_tag t
            LEFT JOIN questions_tagcategory c ON c.id=t.category_id
            LEFT JOIN questions_tagitem i ON i.tag_id=t.id
            LEFT JOIN questions_question q ON q.id=i.object_id
            WHERE q.published
            GROUP BY t.category_id, t.click_count, t.id, t.name, t.slug, c.slug
            ORDER BY c.slug, c DESC, t.slug
            """)
        uncategorized_tags_click_count = Tag.objects.filter(category=None).aggregate(models.Sum('click_count'))['click_count__sum']
        for tag in tags:
            if tag.category:
                category_click_count = annotated_categories[tag.category.id].click_count
            else:
                category_click_count = uncategorized_tags_click_count
            tag.cloud_size = get_cloud_size(tag.click_count, category_click_count)
            context['tag_lists'].setdefault(tag.category.id if tag.category else 0, []).append(tag)
        context['has_uncategorized_tags'] = 0 in context['tag_lists']

        return context

questions/templates/questions/ack_mail.html
{% load i18n chunks %}{% language 'pl' %}
<p>{{ question.created_at }} zarejestrowaliśmy w serwisie PrawoKultury.pl Twoje pytanie:</p>

<blockquote>{{ question.question|linebreaks }}</blockquote>

{% chunk 'questions_ack_mail_html' %}

<p>Dziękujemy za skontaktowanie się z nami!</p>

<p>-- 
<br>{{ site }}
<br>{% endlanguage %}
</p>

questions/templates/questions/answered_mail.html
{% load i18n %}{% language 'pl' %}
<p>{{ question.created_at }} zadałeś/zadałaś pytanie:</p>

<blockquote>{{ question.question|linebreaks }}</blockquote>

<p>Odpowiedź:</p>

<blockquote>{{ question.answer }}</blockquote>

{% if question.published %}
<p>Pytanie wraz z odpowiedzią można znaleźć na stronie:
<a href="http://{{ site.domain }}{{ question.get_absolute_url }}">http://{{ site.domain }}{{ question.get_absolute_url }}</a>
</p>
{% endif %}

<p>Dziękujemy!</p>

<p>-- 
<br>{{ site }}
<br>{% endlanguage %}
</p>

questions/templates/questions/question_detail.html
{% extends "base.html" %}

{% block titleextra %}{{ question|linebreaksbr }} :: {% endblock %}
{% block body %}
<h1>{{ question|linebreaksbr }}</h1>

<div class="normal">
{% if question.tags.all.count %}
<p>Tematy: 
{% for tag in question.tags.all %}
    <a href="{% url 'questions' %}?tag={{ tag.slug }}">{{ tag }}</a>{% if not forloop.last %} / {% endif %}
{% endfor %}
{% endif %}
</p>

{{ question.answer }}

<p>{{ question.answered_by }}</p>

<p><a href="{% url 'questions' %}">Wróć do listy pytań.</a></p>

</div>
{% endblock %}

questions/templates/questions/question_form.html
{% extends "base.html" %}
{% load chunks %}

{% block titleextra %}Pierwsza pomoc w prawie autorskim: pytanie do prawnika :: {% endblock %}
{% block body %}
<h1>Formularz kontaktowy</h1>


<div class="normal">
{% chunk 'questions_form_info' %}
</div>

<form class="submit-form" method="post" action="">
{% csrf_token %}
<table>
    {{ form.as_table }}
    <tr><td></td><td><button>Wyślij</button></td></tr>
</table>
</form>



{% endblock %}

questions/templates/questions/question_list.html
{% extends "base.html" %}
{% load pagination_tags fnp_prevnext %}
{% load pipeline %}
{% load chunks %}

{% block titleextra %}Pierwsza pomoc w prawie autorskim :: {% endblock %}
{% block body %}
<h1>Pierwsza pomoc w prawie autorskim: zapytaj prawnika</h1>

<div class="normal">
{% chunk 'questions_list_info' %}

<div id="questions-filter">
    <h2>Filtruj pytania</h2>
    Wybierz kategorię tematów:
    <div id="questions-categories">
    {% if has_uncategorized_tags %}
    <a href="#" {% if tag and not tag.category %}class="selected"{% endif %} data-category-id="0">bez kategorii</a>
    {% endif %}
    {% for category in tag_categories %}
            <a href="#" style="font-size: {{category.cloud_size}}em;" {% if tag.category == category %}class="selected"{% endif %} data-category-id="{{category.id}}">{{category}}</a>
    {% endfor %}
    </div>

    <div id="questions-subjects">
    {% for category_id, tag_list in tag_lists.items %}
        <div class="questions-tags-group" data-category-id="{{category_id}}">
        Wyświetl tylko na temat:
        {% for atag in tag_list %}
            {% if atag == tag %}<strong style="font-size: {{atag.cloud_size}}em;">{{ atag }}</strong>
            {% else %}<a href="?tag={{ atag.slug }}" style="font-size: {{atag.cloud_size}}em;">{{ atag }}</a>
            {% endif %}
        {% endfor %}
        </div>
    {% endfor %}
    </div>
    <div>
        {% if tag %}<a href=".">Pokaż wszystkie pytania</a>{% endif %}
    </div>
</div>

<h2>Odpowiedzi na już zadane pytania
    {% if tag %}na temat: {{ tag }}{% endif %}
    ({{ object_list.count }}):</h2>

{% autopaginate object_list 20 %}

<ul class='questions'>
{% for question in object_list %}
    <li><a href="{{ question.get_absolute_url }}">{{ question|truncatewords:50 }}</a>
    </li>
{% endfor %}
</ul>

</div>

{% prevnext %}


{% endblock %}

{% block extra_css %}
    {% stylesheet 'questions' %}
{% endblock %}

{% block extra_js %}
    {% javascript 'questions' %}
{% endblock %}

questions/templates/questions/question_thanks.html
{% extends "base.html" %}

{% block titleextra %}Dziękujemy za przesłanie pytania :: {% endblock %}
{% block body %}
<h1>Dziękujemy za przesłanie pytania</h1>

<div class="normal">
<p>Twoje pytanie zostało zapisane. Dziękujemy za kontakt.</p>

<p>Wróć do <a href="{% url 'migdal_main' %}">strony głównej</a>.</p>

</div>
{% endblock %}